import sys
import Gpib
import os

datron = Gpib.Gpib(0,4) # Set this to your meter's GPIB Address - mine is 4

def stringToBytes(aString):
#
# NVRAM IC is on the low 8 bits of the 16 bit bus so we need
# to strip the low bytes from the returned words and discard the high bits
#
  result=''
  tmpArray = aString.split(' ')
  for i in range (0,8):
    result+=chr(int(tmpArray[i+1].strip()[-2:],16))
  return result

def dumpNVRAMRegion(region):
  if region == 'IPZ':
    size = 4096
  elif region == 'PRIM':
    size = 4096
  elif region == 'SECN':
    size = 8192
  else:
    size = 0
    print 'I don\'t know what to do with region ' + region
  if size > 0:
    print 'Dumping '+ region + ' to "' + serial + '.'+region+'.nvram"'
    newFile = open(serial + '.'+region+'.nvram',"wb")
    for i in range(0,size,16):
      datron.write('DUMP? '+ region+','+ str(i))
      tmpString = datron.read(255)
      sys.stdout.write('\r'+str(((i*100)/size))+'% complete')
      sys.stdout.flush()
      tmpString = stringToBytes(tmpString)
      newFile.write(tmpString)
      newFile.close

    sys.stdout.write('\r'+ region + ' done.            \r\n')
    sys.stdout.flush()    

  
    
#Reset the meter
datron.write("*RST")

#Ask for Identity
datron.write("*IDN?")

try:
  temp = datron.read(255)
  tempArray = temp.split(',')
  ID = tempArray[0].strip()
  model = tempArray[1].strip()
  serial = tempArray[2].strip()
  firmware = tempArray[3].strip()
except:
  print "No response to ID command."
  quit()

print "Reading nvram from " + ID + " " + model + " to " + serial + ".X.nvram"


dumpNVRAMRegion('PRIM')
dumpNVRAMRegion('IPZ')
dumpNVRAMRegion('SECN')

print 'Creating ' + serial + '.nvram.bin'
os.system('cat '+ serial + '.IPZ.nvram '+ serial + '.PRIM.nvram ' + serial + '.SECN.nvram > ' + serial + '.nvram.bin') 
print 'Finished.'

